extern int period = 1; // PERIOD  
extern int applied_price = 0;  // APPLIED PRICE (0=CLOSE,1=OPEN,2=HIGH,3=LOW,4=MEDIAN,5=TYPICAL,6=WEIGHTED          
extern int barshift  = 1;           // SHIFT (1=last bar, 2= 2 bars ago, 3= 3 bars ago ect

input string         InpTradeComment      = "Env And Ma";
input int            MagicNum             = 123;
input int            MagicNum2            = 321;
int                  shiftMAenv           = 1;
int                  shiftcandles         = 1;
int                  PriceMode            = PRICE_CLOSE;
int                  Upper                = MODE_UPPER;
int                  Lower                = MODE_LOWER;
double               MaxRiskPerTrade      = 1;
double               LS                   = 0.01;
bool                 CollectOrderData     = true;
bool                 FilterOrders         = true;

int                  Ticket               = 0;
double               IndividualStopLoss   = 0;



//+------------------------------------------------------------------+
//|                                                       Ma10020.mq4 |
//|                        Copyright 2022, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#include <MQLTA ErrorHandling.mqh>
#include <MQLTA Utils.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   IsNewBar();
   CanOpenTrades();
   
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if (!IsNewBar()) return; //
   if (CanOpenTrades()) return;
   
   
   //More than one trade open == don't enter
   
   switch(TradeFilter())   {
      case 1: OpenTrade(1);
      break;
      case 2: OpenTrade(2);
      break;
      case 3: OpenTrade(3);
      break;
      case 4: OpenTrade(4);
      break; 
      case 5: OpenTrade(5);
      break;
      case 6: OpenTrade(6);
      break;
      case 7: OpenTrade(7);
      break;
      case 8: OpenTrade(8);
      break;
      case 9: OpenTrade(9);
      break;
      case 10: OpenTrade(10);
      break;
      case 11: OpenTrade(11);
      break;
      case 12: OpenTrade(12);
      break;
      case 13: OpenTrade(13);
      break;
      case 14: OpenTrade(15);
      break;
      case 16: OpenTrade(16);
      break;
      case 17: OpenTrade(17);
      break;
      case 18: OpenTrade(18);
      break;
      case 19: OpenTrade(19);
      break;
      case 20: OpenTrade(20);
      break;
      case 21: OpenTrade(21);
      break;
      case 22: OpenTrade(22);
      break;
      case 23: OpenTrade(23);
      break;
      case 24: OpenTrade(24);
      break;
      case 25: OpenTrade(25);
      break;
      case 26: OpenTrade(26);
      break;
      case 27: OpenTrade(27);
      break;
      case 28: OpenTrade(28);
      break;
      case 29: OpenTrade(29);
      break;
      case 30: OpenTrade(30);
      break;
      case 31: OpenTrade(31);
      break;
      case 32: OpenTrade(32);
      break;
      
      default: 
      break;
      }
      
if (OrdersTotal()==0)                                                                                 //If total number of orders open is 0, return 0 (do nothing)
   {
      return;
   }

   
   static int GuestTicket;
   static double GuestFib61BUY;
   static double GuestFib61SELL;
   static double GuestFib261BUY;
   static double GuestFib261SELL;
   static double GuestOrderOpenPrice;
   

if (CollectOrderData == true) OrderValues(GuestTicket, GuestFib61BUY, GuestFib61SELL, GuestFib261BUY, GuestFib261SELL, GuestOrderOpenPrice);
if (FilterOrders == true)     FilterOrders(GuestTicket, GuestFib61BUY, GuestFib61SELL, GuestFib261BUY, GuestFib261SELL, GuestOrderOpenPrice);


            
   //Monitor open trades >>> Update SL when surpasses Fib and Closs trades on 288 MA 2 candle close cross   
      
      //If 2 candles close under the 288, close open buy trades
      //If 2 candles close over the 288, close open sell trades.
}      
      
  
//+------------------------------------------------------------------+




bool CanOpenTrades() {


   int TotalOrders = 0;
   TotalOrders = OrdersTotal();                          //static variable to take new value on each loop
   bool AreOpenTrades = (TotalOrders > 0);             //AreOpenTrades is true while NumberofOpenTrades is more than 0 // aka there are more than 0 trades (1+)      //If there are open trades, the total number of trades is assigned to NumberofTrades
   return (AreOpenTrades);                                            // eg, theres 1 open trade >> AreOpenTrades is true >>> Number of AreOpenTrades now equals 1 >>> the function returns true
                                             // When the trades close, OrdersTotal will be 0, and NumberofTrades will be assigned 0, so 0 is not equal to 0 is false and we can open trades
   }
   
   




/*The following function works using this 1H example of a new bar at 2.00.00:
currentTime = 1.00.00
result = True (1.00.00 does not equal 2.00.00)
because result = True : currentTime is assigned the value 2.00.00 (the open time of the current candle.
return result which is True
NEXTLOOP
currentTime = 2.00.00
result = False (2.00.00 DOES equal 2.00.00)
return False
if (!IsNewBar()) return; >>> Now this loop will stop executing and move to the next line of OnTick() 
>>> ! means NOT, and result inside the IsNewBar function was originally assigned a True value to return because of the default value of CT (0)
because this is no longer true at the start of a candle, the function returns false
our function is waiting for IsNewBar to not be True (!) and when it is, we can execute the next line in OnTick()

*/
bool IsNewBar() { // a function to determine if it is a new bar

   static datetime   currentTime = 0;     //Data type is 'static datetime'. currentTime variable = Current candle time is 0.
   bool result = (currentTime!=Time[0]);  //Data type = bool. 'Result' is True while the current time is not equal to the current candle open time.
   if (result)   currentTime = Time[0];   //If return is True, change currentTime value to current bar open time.
   return(result);                        //return True or False
   
   }
   
   
   /*
   
   TradeFilter() is a function to identify trade conditions
   For the strategy we need:
   MA > EXPONENTIAL >> 2016 >> CLOSE
   MA > EXPONENTIAL >> 288 >> CLOSE
   MA > SIMPLE > 20 > CLOSE
   MA > SIMPLE > 50 >> CLOSE
   ENV > EXPONENTIAL > 2016 >> CLOSE 
         DEV .50, 1.0, 1.5, 2, 2.5, 3, 3.5, 4, 4.5, 5, 5.5, 6
                   
         
 3 TYPES WITH 2 BUY/SELL VARIATIONS EACH >>>>> CLOSE MUST BE ON ONE SIDE OF THE 288 MA (UNDER FOR SELL, OVER FOR BUY)
 
 1) 1 CANDLE - HIGH ABOVE 50, HIGH BELOW 288, CROSS ENV >>> 50 < 288 (VICE VERSA FOR BUY)
                           
 2) 1 CANDLE - HIGH ABOVE 50, HIGH BELOW 288, HIGH ABOVE ENV, OPEN BELOW ENV, CLOSE BELOW ENV >>> 50 < 288 (VICE VERSA FOR BUY)
     
 3) 1 CANDLE - HIGH ABOVE 50, HIGH BELOW 288, OPEN ABOVE 50, CLOSE BELOW 20 >>> 20 < 50 < 288 (VICE VERSA FOR BUY)
 
   */

int TradeFilter() { 

double MA2016 = iMA(NULL,0, 2016, 0, MODE_EMA, PriceMode, shiftMAenv);                      // PREVIOUS CANDLE VALUE
double MA288 = iMA(NULL,0, 288, 0, MODE_EMA, PriceMode, shiftMAenv);                        // PREVIOUS CANDLE VALUE
double MA50 = iMA(NULL,0, 50, 0, MODE_SMA, PriceMode, shiftMAenv);                          // PREVIOUS CANDLE VALUE
double MA20 = iMA(NULL,0, 20, 0, MODE_SMA, PriceMode, shiftMAenv);                          // PREVIOUS CANDLE VALUE
double ENV05UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 0.50, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV05LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 0.50, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV10UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 1.00, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV10LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 1.00, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV15UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 1.50, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV15LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 1.50, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV20UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 2.00, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV20LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 2.00, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV25UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 2.50, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV25LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 2.50, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV30UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 3.00, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV30LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 3.00, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV35UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 3.50, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV35LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 3.50, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV40UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 4.00, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV40LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 4.00, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE 

double LastHigh = iHigh(NULL,5,shiftcandles);
double LastLow = iLow(NULL,5,shiftcandles);
double LastOpen = iOpen(NULL,5,shiftcandles);
double LastClose = iClose(NULL,5,shiftcandles); 

//1) 1 CANDLE - HIGH ABOVE 50, HIGH BELOW 288, HIGH ABOVE ENV >>> CLOSE BELOW >>> 50 < 288 (VV FOR SELL)

//   CANDLE CAN CROSS AND CLOSE WITH BODY OR REJECT WITH WICK
 
//   

   if ((LastHigh > MA50 && LastHigh < MA288) && (LastHigh > MA2016 && LastClose < MA2016) && MA50 < MA288) 
      {
      return (1); // SELL
      }
   if ((LastLow < MA50 && LastLow > MA288) && (LastLow < MA2016 && LastClose > MA2016) && MA50 > MA288) 
      {     
      return (2); // BUY
      }
   
   if ((LastHigh > MA50 && LastHigh < MA288) && (LastHigh > ENV05UPPER && LastClose < ENV05UPPER) && MA50 < MA288) 
      {
      return (3); 
      }
   if ((LastLow < MA50 && LastLow > MA288) && (LastLow < ENV05UPPER && LastClose > ENV05UPPER) && MA50 > MA288)
      {
      return (4); 
      }
   
   if ((LastHigh > MA50 && LastHigh < MA288) && (LastHigh > ENV05LOWER && LastClose < ENV05LOWER) && MA50 < MA288) 
      {
      return (5);
      }
   if ((LastLow < MA50 && LastLow > MA288) && (LastLow < ENV05LOWER && LastClose > ENV05LOWER) && MA50 > MA288) 
      {
      return (6); 
      }
   
   if ((LastHigh > MA50 && LastHigh < MA288) && (LastHigh > ENV10UPPER && LastClose < ENV10UPPER) && MA50 < MA288) 
      {
      return (7); 
      }
   if ((LastLow < MA50 && LastLow > MA288) && (LastLow < ENV10UPPER && LastClose > ENV10UPPER) && MA50 > MA288) 
      {
      return (8); 
      }
      
   if ((LastHigh > MA50 && LastHigh < MA288) && (LastHigh > ENV10LOWER && LastClose < ENV10LOWER) && MA50 < MA288)
      {
      return (9); 
      }
   if ((LastLow < MA50 && LastLow > MA288) && (LastLow < ENV10LOWER && LastClose > ENV10LOWER) && MA50 > MA288) 
      {
      return (10); 
      }
     
   if ((LastHigh > MA50 && LastHigh < MA288) && (LastHigh > ENV15UPPER && LastClose < ENV15UPPER) && MA50 < MA288) 
      {
      return (11); 
      }   
   if ((LastLow < MA50 && LastLow > MA288) && (LastLow < ENV15UPPER && LastClose > ENV15UPPER) && MA50 > MA288) 
      {
      return (12); 
      }
   
   if ((LastHigh > MA50 && LastHigh < MA288) && (LastHigh > ENV15LOWER && LastClose < ENV15LOWER) && MA50 < MA288) 
      {
      return (13);
      } 
   if ((LastLow < MA50 && LastLow > MA288) && (LastLow < ENV15LOWER && LastClose > ENV15LOWER) && MA50 > MA288) 
      {
      return (14);   
      }
   
   if ((LastHigh > MA50 && LastHigh < MA288) && (LastHigh > ENV20UPPER && LastClose < ENV20UPPER) && MA50 < MA288) 
      {
      return (15); 
      }
   if ((LastLow < MA50 && LastLow > MA288) && (LastLow < ENV20UPPER && LastClose > ENV20UPPER) && MA50 > MA288) 
      {
      return (16);     
      }

   if ((LastHigh > MA50 && LastHigh < MA288) && (LastHigh > ENV20LOWER && LastClose < ENV20LOWER) && MA50 < MA288) 
      {
      return (17);
      }
   if ((LastLow < MA50 && LastLow > MA288) && (LastLow < ENV20LOWER && LastClose > ENV20LOWER) && MA50 > MA288) 
      {
      return (18);    
      }
  
   if ((LastHigh > MA50 && LastHigh < MA288) && (LastHigh > ENV25UPPER && LastClose < ENV25UPPER) && MA50 < MA288) 
      {
      return (19); 
      }
   if ((LastLow < MA50 && LastLow > MA288) && (LastLow < ENV25UPPER && LastClose > ENV25UPPER) && MA50 > MA288) 
      {
      return (20);      
      }  
   
   if (LastHigh > MA50 && LastHigh < MA288 && LastHigh > ENV25LOWER && LastClose < ENV25LOWER && MA50 < MA288) 
      {
      return (21); 
      }
   if (LastLow < MA50 && LastLow > MA288 && LastLow < ENV25LOWER && LastClose > ENV25LOWER && MA50 > MA288) 
      {
      return (22);   
      }       
   
   if (LastHigh > MA50 && LastHigh < MA288 && LastHigh > ENV30UPPER && LastClose < ENV30UPPER && MA50 < MA288) 
      {
      return (23);
      } 
   if (LastLow < MA50 && LastLow > MA288 && LastLow < ENV30UPPER && LastClose > ENV30UPPER && MA50 > MA288) 
      {
      return (24);    
      }    
   
   if (LastHigh > MA50 && LastHigh < MA288 && LastHigh > ENV30LOWER && LastClose < ENV30LOWER && MA50 < MA288) 
      {
      return (25);
      }
   if (LastLow < MA50 && LastLow > MA288 && LastLow < ENV30LOWER && LastClose > ENV30LOWER && MA50 > MA288) 
      {
      return (26); 
      }      
   
   if (LastHigh > MA50 && LastHigh < MA288 && LastHigh > ENV35UPPER && LastClose < ENV35UPPER && MA50 < MA288) 
      {
      return (27); 
      }
   if (LastLow < MA50 && LastLow > MA288 && LastLow < ENV35UPPER && LastClose > ENV35UPPER && MA50 > MA288) 
      {
      return (28);    
      }  
   
   if (LastHigh > MA50 && LastHigh < MA288 && LastHigh > ENV35LOWER && LastClose < ENV35LOWER && MA50 < MA288) 
      {
      return (29); 
      }
   if (LastLow < MA50 && LastLow > MA288 && LastLow < ENV35LOWER && LastClose > ENV35LOWER && MA50 > MA288)
      {
      return (30);  
      }       
     
   if (LastHigh > MA50 && LastHigh < MA288 && LastHigh > ENV40LOWER && LastClose < ENV40LOWER && MA50 < MA288) 
      {
      return (31); 
      }
   if (LastLow < MA50 && LastLow > MA288 && LastLow < ENV40UPPER && LastClose > ENV40UPPER && MA50 > MA288) 
      {
      return (32);  
      }
      
   
      
// 2) 1 CANDLE - HIGH ABOVE 50, HIGH BELOW 288, OPEN ABOVE 50, CLOSE BELOW 20 >>> HIGH BELOW ENV >>> 20 < 50 < 288 (VICE VERSA FOR BUY)



   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < MA2016 && MA20 < MA50 && MA50 < MA288) return (5);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > MA2016 && MA20 > MA50 && MA50 > MA288) return (4); 
   
   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV05UPPER && MA20 < MA50 && MA50 < MA288) return (1);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV05UPPER && MA20 > MA50 && MA50 > MA288) return (8); 

   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV05LOWER && MA20 < MA50 && MA50 < MA288) return (9);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV05LOWER && MA20 > MA50 && MA50 > MA288) return (2); 

   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV10UPPER && MA20 < MA50 && MA50 < MA288) return (3);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV10UPPER && MA20 > MA50 && MA50 > MA288) return (12); 

   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV10LOWER && MA20 < MA50 && MA50 < MA288) return (13);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV10LOWER && MA20 > MA50 && MA50 > MA288) return (6); 

   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV15UPPER && MA20 < MA50 && MA50 < MA288) return (7);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV15UPPER && MA20 > MA50 && MA50 > MA288) return (16); 

   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV15LOWER && MA20 < MA50 && MA50 < MA288) return (17);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV15LOWER && MA20 > MA50 && MA50 > MA288) return (10); 

   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV20UPPER && MA20 < MA50 && MA50 < MA288) return (11);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV20UPPER && MA20 > MA50 && MA50 > MA288) return (20); 

   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV20LOWER && MA20 < MA50 && MA50 < MA288) return (21);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV20LOWER && MA20 > MA50 && MA50 > MA288) return (14); 

   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV25UPPER && MA20 < MA50 && MA50 < MA288) return (15);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV25UPPER && MA20 > MA50 && MA50 > MA288) return (24); 

   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV25LOWER && MA20 < MA50 && MA50 < MA288) return (25);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV25LOWER && MA20 > MA50 && MA50 > MA288) return (18); 
   
   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV30UPPER && MA20 < MA50 && MA50 < MA288) return (19);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV30UPPER && MA20 > MA50 && MA50 > MA288) return (28); 

   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV30LOWER && MA20 < MA50 && MA50 < MA288) return (29);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV30LOWER && MA20 > MA50 && MA50 > MA288) return (22); 
   
   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV35UPPER && MA20 < MA50 && MA50 < MA288) return (23);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV35UPPER && MA20 > MA50 && MA50 > MA288) return (31); 

   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV35LOWER && MA20 < MA50 && MA50 < MA288) return (32);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV35LOWER && MA20 > MA50 && MA50 > MA288) return (26); 
        
   if (LastHigh > MA50 && LastHigh < MA288 && LastOpen > MA50 && LastClose < MA20 && LastHigh < ENV40UPPER && MA20 < MA50 && MA50 < MA288) return (27);
   if (LastLow < MA50 && LastLow > MA288 && LastOpen < MA50 && LastClose > MA20 && LastHigh > ENV40LOWER && MA20 > MA50 && MA50 > MA288) return (30); 
  
      else return(0);
   
   }



   
void  OpenTrade(int number)   {

double MA2016 = iMA(NULL,0, 2016, 0, MODE_EMA, PriceMode, shiftMAenv);                      // PREVIOUS CANDLE VALUE
double MA288 = iMA(NULL,0, 288, 0, MODE_EMA, PriceMode, shiftMAenv);                        // PREVIOUS CANDLE VALUE
double MA50 = iMA(NULL,0, 50, 0, MODE_SMA, PriceMode, shiftMAenv);                          // PREVIOUS CANDLE VALUE
double MA20 = iMA(NULL,0, 20, 0, MODE_SMA, PriceMode, shiftMAenv);                          // PREVIOUS CANDLE VALUE
double ENV05UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 0.50, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV05LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 0.50, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV10UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 1.00, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV10LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 1.00, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV15UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 1.50, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV15LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 1.50, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV20UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 2.00, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV20LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 2.00, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV25UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 2.50, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV25LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 2.50, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV30UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 3.00, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV30LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 3.00, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV35UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 3.50, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV35LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 3.50, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE   
double ENV40UPPER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 4.00, Upper, shiftMAenv);  // PREVIOUS CANDLE VALUE
double ENV40LOWER = iEnvelopes(NULL, 0, 2016, MODE_EMA, 0, PriceMode, 4.00, Lower, shiftMAenv);  // PREVIOUS CANDLE VALUE 

double LastHigh = iHigh(NULL,5,shiftcandles);
double LastLow = iLow(NULL,5,shiftcandles);
double LastOpen = iOpen(NULL,5,shiftcandles);
double LastClose = iClose(NULL,5,shiftcandles);


   ENUM_ORDER_TYPE orderType = 0;
   double openPrice = 0;
   double TPPriceFIB161 = 0;
   double TPPriceFIB423 = 0;
   double stopLossPrice = 0;
   double DistanceSLtoOpen = 0;
   double Risk = 0;
   double LotSize = 0;
   double DistanceMult61 = 0;
   double DistanceMult323 = 0;
   double DistanceMult61Norm = 0;
   double DistanceMult323Norm = 0;

   
 
 
 //METHOD 1
   
if (number == 1) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV05UPPER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm; 
      
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
           
 
} else if (number == 2) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV05LOWER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;

      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);

      
} else if (number == 3) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV10UPPER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm;
             
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
 
} else if (number == 4) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = MA2016;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
            
} else if (number == 5) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = MA2016;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm; 
            
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
 
} else if (number == 6) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV10LOWER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
} else if (number == 7) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV15UPPER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm;  
           
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
 
} else if (number == 8) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV05UPPER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
} else if (number == 9) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV05LOWER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm;
             
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
 
} else if (number == 10) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV15LOWER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);

} else if (number == 11) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV20UPPER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm;
             
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
 
} else if (number == 12) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV10UPPER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);

} else if (number == 13) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV35UPPER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm; 
            
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
 
} else if (number == 14) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV20LOWER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
} else if (number == 15) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV25UPPER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm;  
           
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
 
} else if (number == 16) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV15UPPER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
} else if (number == 17) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV15LOWER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm;
            
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
       
} else if (number == 18) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV25LOWER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
} else if (number == 19) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV30UPPER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm;  
           
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
 
} else if (number == 20) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV20UPPER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
} else if (number == 21) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV20LOWER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm;
             
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
 
} else if (number == 22) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV30LOWER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
} else if (number == 23) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV35UPPER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm; 
            
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
 
} else if (number == 24) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV25UPPER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
} else if (number == 25) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV25LOWER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm; 
            
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);      
 
} else if (number == 26) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV35LOWER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
} else if (number == 27) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV40UPPER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm; 
            
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
 
} else if (number == 28) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV30UPPER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
} else if (number == 29) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV30LOWER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm;
             
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
 
} else if (number == 30) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV40LOWER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
     
      
} else if (number == 31) {
      
      orderType = ORDER_TYPE_BUY;
      openPrice = Ask;
      stopLossPrice = ENV35UPPER;
      DistanceSLtoOpen = openPrice - stopLossPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Ask + DistanceMult61Norm;
      TPPriceFIB423 = Ask + DistanceMult323Norm;
      
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
      
} else if (number == 32) { //SELL
   
      orderType = ORDER_TYPE_SELL;
      openPrice = Bid;
      stopLossPrice = ENV35LOWER;
      DistanceSLtoOpen = stopLossPrice - openPrice;
      DistanceMult61 = DistanceSLtoOpen*0.61;
      DistanceMult323 = DistanceSLtoOpen*3.23;
      DistanceMult61Norm = NormalizeDouble(DistanceMult61, 2);
      DistanceMult323Norm = NormalizeDouble(DistanceMult323, 2);
      TPPriceFIB161 = Bid - DistanceMult61Norm;  
      TPPriceFIB423 = Bid - DistanceMult323Norm; 
            
      Risk = ((AccountBalance()*1)/100);
      LotSize = Risk/(DistanceSLtoOpen*100);
 
}  

 //   double LS = openPrice - stopLossPrice; = NormalizeDouble(AccountFreeMargin() * ((MaxRiskPerTrade /100) / 1000.0), LotDigits)
   
      
    int ticket1 = OrderSend(Symbol(), orderType, LotSize, openPrice, 0, stopLossPrice, TPPriceFIB161, InpTradeComment, MagicNum);
    int ticket2 = OrderSend(Symbol(), orderType, LotSize, openPrice, 0, stopLossPrice, TPPriceFIB423, InpTradeComment, MagicNum2);
 
     
     
      
return;


}



void OrderValues(int& ResForTicket, double& ResForFib61BUY, double& ResForFib61SELL, double& ResForFib261BUY, double& ResForFib261SELL, double& ResForOrderOpenPrice)

{

for(int i = OrdersTotal() -1; i <=0; i --)                                       //For all orders in descending order

   {
   
      if(OrderSelect(i,SELECT_BY_POS, MODE_TRADES))                              //Select order by index number

         {
         
            if (OrderMagicNumber() == MagicNum2)
            
               {
         
      double Fib61DistPipsBUY        = 0;
      double Fib61DistPipsSELL       = 0;
      double Fib261DistPipsBUY       = 0;
      double Fib261DistPipsSELL      = 0;
      double Fib61BUY                = 0;
      double Fib61SELL               = 0;
      double Fib261BUY               = 0;
      double Fib261SELL              = 0;
      double Fib61PriceBUY           = 0;
      double Fib61PriceSELL          = 0;
      double Fib261PriceBUY          = 0;
      double Fib261PriceSELL         = 0;
      
      Fib61DistPipsBUY              = ((OrderStopLoss() - OrderOpenPrice()) * 0.61);
      Fib61DistPipsSELL             = ((OrderOpenPrice() - OrderStopLoss()) * 0.61);
      Fib261DistPipsBUY             = ((OrderStopLoss() - OrderOpenPrice()) * 1.61);
      Fib261DistPipsSELL            = ((OrderOpenPrice() - OrderStopLoss()) * 1.61);
      
      Fib61BUY                      = (OrderOpenPrice() + Fib61DistPipsBUY);
      Fib61SELL                     = (OrderOpenPrice() - Fib61DistPipsSELL);
      Fib261BUY                     = (OrderOpenPrice() + Fib261DistPipsBUY);
      Fib261SELL                    = (OrderOpenPrice() - Fib261DistPipsSELL);
      
      Fib61PriceBUY                 = NormalizeDouble(Fib61BUY,2);
      Fib61PriceSELL                = NormalizeDouble(Fib61SELL,2);
      Fib261PriceBUY                = NormalizeDouble(Fib261BUY,2);
      Fib261PriceSELL               = NormalizeDouble(Fib261SELL,2);
      
      ResForTicket                  = OrderTicket();
      ResForFib61BUY                = Fib61PriceBUY;
      ResForFib61SELL               = Fib61PriceSELL;
      ResForFib261BUY               = Fib261PriceBUY;
      ResForFib261SELL              = Fib261PriceSELL;
      ResForOrderOpenPrice          = OrderOpenPrice();
      
      
      
         
      //    FilterOrders(OrderTicket(), Fib61PriceBUY, Fib261PriceBUY, Fib61PriceSELL, Fib261PriceSELL);
          
          
          
          }
         } 
       }
    }   
    










 void FilterOrders(int& ResForTicket, double& ResForFib61BUY, double& ResForFib61SELL, double& ResForFib261BUY, double& ResForFib261SELL, double& ResForOrderOpenPrice)
 
 {

   if(OrderSelect(ResForTicket, SELECT_BY_TICKET)==true)                             //Select order by index number
   
      {
        
         if((OrderType() == OP_BUY) && (Ask > ResForFib61BUY)) ModifyStopLoss(ResForTicket, ResForOrderOpenPrice, ResForOrderOpenPrice);
         if((OrderType() == OP_BUY) && (Ask > ResForFib261BUY)) ModifyStopLoss(ResForTicket, ResForFib61BUY, ResForOrderOpenPrice);
         if((OrderType() == OP_SELL) && (Bid < ResForFib61SELL)) ModifyStopLoss(ResForTicket, ResForOrderOpenPrice, ResForOrderOpenPrice);
         if((OrderType() == OP_SELL) && (Bid < ResForFib261SELL)) ModifyStopLoss(ResForTicket, ResForFib61SELL, ResForOrderOpenPrice);
         else return;
         
         }
      } 
  

      
        
          

// BUY EXAMPLE >> OP 1845.32 - SL 1834.67 = 10.65 (DistanceSLtoOpenSell) >>>      SL TO OPEN DISTANCE IN PIPS
// 10.65 (DistanceSLtoOpenSell) * 0.61 = 6.4965 (Fib61BuyDistance) >>>            OPEN TO 61 FIB DISTANCE IN PIPS
// 1845.32 (OpenPrice) + 6.49 (Fib61BuyDistPips = 1851.81 (Fib 0.61 Price Level)  OPEN + 61 FIB DISTANCE IN PIPS = 61 FIB LEVEL PRICE (NEEDS TO BE NORMALIZED
//

        
               
void ModifyStopLoss(int& ResForTicket, double& ResForNewSL, double& ResForOrderOpenPrice)
{
   if(OrderSelect(ResForTicket, SELECT_BY_TICKET)==true)                                                          //if the order selected by ticket is found
   {
      if(OrderModify(ResForTicket,ResForOrderOpenPrice,ResForNewSL, OrderTakeProfit(),0,Plum))
      return;
      }
   }


          
               
               
               
           